#include <GUIConstants.au3>
#include <string.au3>

Global $folder																	;    ,    
Global $sourcefolder															;    
Global $sourcepath																;        
Global $targetfile																;     
Global $targetfolder															;   ,     
Global $sourcefile																;     ,   
Global $compress																;  " "
Global $compressed																;  
Global $bsdtar																	;   

Opt ( "GUIOnEventMode", 1 )														; GUI    Event Mode

$bsdtar = @ScriptDir & "\bsdtar.exe"											;    bsdtar.exe
$config = @ScriptDir & "\config.ini"  											;  

GUICreate ( "  bsdtar", 330, 140 )							;   
GUISetBkColor(0x00E0FFFF)														;   

$source = GUICtrlCreateButton ( " ",  10, 10, 100 )					;     
GUICtrlSetTip ( -1,"    " )
GUICtrlSetOnEvent ( $source, "GetSource")										;     GetSource

$compress = GUICtrlCreateCheckbox ( " ", 230, 12, 100, 20 )			;  " "
GUICtrlSetTip ( -1," ,    *.tgz,  - *tar" )

$target = GUICtrlCreateButton ( " ...",  120, 10, 100 )				;    
GUICtrlSetTip ( -1,"      " )
GUICtrlSetOnEvent ( $target, "GetTarget")										;     GetTarget

$beginpack = GUICtrlCreateButton ( " ", 10, 40, 310 )				;    
GUICtrlSetState ( $beginpack, $GUI_DISABLE )									;   
GUICtrlSetOnEvent ( $beginpack, "Pack" )										;     Pack

$archive = GUICtrlCreateButton ( " ", 10, 70, 100 )					;    
GUICtrlSetTip ( -1,"   " )
GUICtrlSetOnEvent ( $archive, "GetArchive" )									;     GetArchive

$rewrite = GUICtrlCreateCheckbox ( "", 230, 72, 100, 20 )			;  ""
GUICtrlSetTip ( -1," ,    " )

$unpack = GUICtrlCreateButton ( " ...", 120, 70, 100 )				;      
GUICtrlSetTip ( -1," ,     " )
GUICtrlSetOnEvent ( $unpack, "UnpackTo" )										;     UnpackTo

$beginunpack = GUICtrlCreateButton ( " ", 10, 100, 310 )		;    
GUICtrlSetState ( $beginunpack, $GUI_DISABLE )									;   
GUICtrlSetOnEvent ( $beginunpack, "Unpack" )									;     Unpack

GUISetOnEvent ( $GUI_EVENT_CLOSE, "CLOSEClicked" )								;  CLOSEClicked    
GUISetState ()																	; 



Func GetSource ()
$inisourcefolder = IniRead ( $config, "bsdtar", "SourceFolder", ""	)			;    -
$folder =  FileSelectFolder ( " ,    ", "", 2, $inisourcefolder )	;     
$lastslash = StringInStr ( $folder, "\", 0, -1 )								;        -
$sourcepath = StringMid ( $folder, 1, $lastslash-1 )							;     
$sourcefolder = StringTrimLeft ( $folder, $lastslash )							;     
	If $folder <> "" Then													;   ,
		IniWrite ( $config, "bsdtar", "SourceFolder", $folder )					;     
	EndIf
	If $targetfile <> "" Then													;      ,
		GUICtrlSetState ( $beginpack, $GUI_ENABLE )								;    ""
	EndIf
EndFunc

Func GetTarget ()
$initargetfile = IniRead ( $config, "bsdtar", "TargetFile", ""	)				;      
$targetfile =  FileSaveDialog ( "      ", $initargetfile, "(*.tar;*.tgz)", 16 )	;    
	If $targetfile <> "" Then													;   ,
		IniWrite ( $config, "bsdtar", "TargetFile", $targetfile )				;     
	EndIf
	If $sourcefolder <> "" Then													;    -,
		GUICtrlSetState ( $beginpack, $GUI_ENABLE )								;    ""
	EndIf
EndFunc

Func Pack ()
$compressed = GUICtrlRead ( $compress )
	If $compressed = 1 Then														;   
		$ext_tgz = StringInStr ( $targetfile, ".tgz" )							; ,      .tgz
			If $ext_tgz = 0 Then												;   ,
				$targetfile = $targetfile & ".tgz"								;  
			EndIf
$command = '"' & $bsdtar & '"' & ' -cvz -f ' & '"' & $targetfile & '"' & " -C " & $sourcepath & ' "' & $sourcefolder & '"' 	;     
	Else																		;   
		$ext_tar = StringInStr ( $targetfile, ".tar" )							; ,      .tar
			If $ext_tar = 0 Then												;   ,
				$targetfile = $targetfile & ".tar"								;  
			Endif
$command = '"' & $bsdtar & '"' & ' -cvf ' & '"' & $targetfile & '"' & " -C " & $sourcepath & ' "' & $sourcefolder & '"'	;     
	EndIf	
		$Go = Run ( $command )													;  
		ProcessWaitClose ( $Go )												;       	
EndFunc

Func GetArchive ()
$inisourcefile = IniRead ( $config, "bsdtar", "SourceFile", "" )				;    -
$sourcefile = FileOpenDialog ( " ", $inisourcefile, "(*.tgz;*.tar)", 1 )		;   
	If $sourcefile <> "" Then													;    ,
		IniWrite ( $config, "bsdtar", "SourceFile", $sourcefile )				;     
	EndIf
	If $targetfolder <> "" Then													;     ,
		GUICtrlSetState ( $beginunpack, $GUI_ENABLE )							;    ""
	EndIf
EndFunc

Func UnpackTo ()
$initargetfolder = IniRead ( $config, "bsdtar", "TargetFolder", ""	)			;     
$targetfolder = FileSelectFolder ( " ,     ", "", 2, $initargetfolder )	;   
	If $targetfolder <> "" Then
		IniWrite ( $config, "bsdtar", "TargetFolder", $targetfolder )			;     
	EndIf
	If $sourcefile <> "" Then													;     ,
		GUICtrlSetState ( $beginunpack, $GUI_ENABLE )							;    ""
	EndIf
EndFunc

Func Unpack ()
If $rewrite = 1 Then															;   ,
	$command = '"' & $bsdtar & '"' & " -xv -f " & '"' & $sourcefile & '"' & " -C " & '"' & $targetfolder & '"'		;      
Else																			;    
	$command = '"' & $bsdtar & '"' & " -xvk -f " & '"' & $sourcefile & '"' & " -C " & '"' & $targetfolder & '"'	;      
EndIf
$Go = Run ( $command )															;  
ProcessWaitClose ( $Go )														;     
EndFunc

Func CLOSEClicked ()
Exit
EndFunc


While 1
$msg = GUIGetMsg ()
    If $msg = $GUI_EVENT_CLOSE Then ExitLoop
Wend

Exit